#include "stdafx.h"


void trimLink(LPCSTR str, int length, LPTSTR buf, bool convert=false);

   
int skipSpaceW(LPCTSTR buffer, int size)
{
	int result = 0;
	while (result < size)
	{
		if (buffer[result] == _T(' '))
		{
			result ++;
		}
		else
		{
			return result;
		}
	}
	return -1;
}

int skipSpaceA(LPCSTR buffer, int size)
{
	int result = 0;	  	
	while (result < size)
	{
		if (buffer[result] == ' ')
		{
			result ++;
		}
		else
		{
			return result;
		}
	}
	return -1;
}


int findFirstCharW(LPCTSTR buffer, int size, TCHAR ch)
{
	int result = 0;
	bool insideQuote = false;

	while (result < size)
	{
		if (!insideQuote)
		{
			if (towupper(buffer[result]) == towupper(ch))
			{
				return result;
			}
			if (buffer[result] == _T('"'))
			{
				insideQuote = true;
			}
		}
		else
		{
			if (buffer[result] == _T('"'))
			{
				insideQuote = false;
			}
		}

		result ++;
	}
	return -1;
}

int findFirstStringW(LPCTSTR buffer, int size, LPCTSTR subStr)
{
	int result = 0;
	int offset;
	int bufSize = size;
	int subLen = _tcslen(subStr);
	while (result < size)
	{
		offset = findFirstCharW(buffer + result, size - result, subStr[0]);
		if (offset < 0)
		{
			return -1;
		}
		result += offset;
		if (size - result < subLen)
		{
			return  -1;
		}
		if (_tcsnicmp(buffer + result, subStr, subLen) == 0)
		{
			return result;
		}
		else
		{
			result ++;
		}
	}
	
	return -1;
}

int findNextCharW(LPCTSTR buffer, int size, TCHAR ch)
{
	int result = 0;
	while (result < size)
	{
		if (buffer[result] == _T(' '))
		{
			result++;
		}
		else
		{
			if(towupper(buffer[result])==towupper(ch))
			{
				return result;
			}
			else
			{
				return -1;
			}
		}
	}
	return -1;
}

int findNextStringW(LPCTSTR buffer, int size, LPCTSTR subStr)
{
	int result = 0;
	int subLen = 0;
	result = findNextCharW(buffer, size, subStr[0]);
	if (result < 0)
	{
		return -1;
	}
	subLen = _tcslen(subStr);
	if (size - result <	subLen)
	{
		return -1;
	}
	if (_tcsnicmp(buffer + result, subStr, subLen) == 0)
	{
		return result;
	}
	else
	{
		return -1;
	}
}
//quote will be removed, end is boundary
bool findFirstWordW(LPCTSTR buffer, int size, int& start, int& end)
{
	start = end =0;
	bool isQuote = false;
	bool isBegin = false;
	bool isEnd   = false;
	while (start < size)
	{  	
		if (buffer[start]!=_T('"') && buffer[start]!=_T(' '))
		{
			break;		 
		} 
	
		if (buffer[start]==_T('"'))
		{
			if (!isQuote)
			{
				isQuote = true;
			}
			else
			{
				end = start;
				return false;
			}
		}
		start ++;
	}

	if (start>= size)
	{
		return false;
	}
	end = start;
	while (end < size)
	{
		if (isQuote)
		{
			if (buffer[end] == _T('"'))
			{
				break;
			}
		}
		else
		{
			if (buffer[end]==_T(' ')||buffer[end]==_T('>'))
			{
				break;
			}
		}
		end++;
	}
	/*
	if (isQuote)
	{
		while (end > start)
		{
			if (buffer[end - 1]==_T(' '))
			{
				end --;
			}
			else
			{
				break;
			}
		}
	}
	*/
	if (end>= size)
	{
		return false;
	}
	return true;
}

int findFirstSymbolA(LPCSTR buffer, int size, char ch)
{
	int result = 0;
	while (result < size)
	{  	
		if (toupper(buffer[result]) == toupper(ch))
		{
			return result;
		}  	
		result ++;
	}
	return -1;
}


int findFirstCharA(LPCSTR buffer, int size, char ch)
{
	int result = 0;
	bool insideQuote = false;
	while (result < size)
	{
		if (!insideQuote)
		{  
			if (toupper(buffer[result]) == toupper(ch))
			{
				return result;
			}
			if (buffer[result] == '"'||buffer[result]=='\'')
			{
				insideQuote = true;
			}
		}
		else
		{
			if (buffer[result] == '"'||buffer[result]=='\'')
			{
				insideQuote = false;
			}
		}
		result ++;
	}
	return -1;
}

int findFirstStringA(LPCSTR buffer, int size, LPCSTR subStr)
{
	int result = 0;
	int offset;
	int bufSize = size;
	int subLen = strlen(subStr);
	while (result < size)
	{
		offset = findFirstCharA(buffer + result, size - result, subStr[0]);
		if (offset < 0)
		{
			return -1;
		}
		result += offset;
		if (size - result < subLen)
		{
			return  -1;
		}
		if (strnicmp(buffer + result, subStr, subLen) == 0)
		{
			return result;
		}
		else
		{
			result ++;
		}
	}
	
	return -1;
}

int findNextCharA(LPCSTR buffer, int size, char ch)
{
	int result = 0;

	while (result < size)
	{
		if (buffer[result] ==' ')
		{
			result++;
		}
		else
		{
			if (buffer[result] == '>')
			{
				return -1;
			}
			if(toupper(buffer[result])==toupper(ch))
			{
				return result;
			}
			else
			{
				return -1;
			}
		}
	}
	return -1;
}

int findNextStringA(LPCSTR buffer, int size, LPCSTR subStr)
{
	int result = 0;
	int subLen = 0;
	result = findNextCharA(buffer, size, subStr[0]);
	if (result < 0)
	{
		return -1;
	}
	subLen = strlen(subStr);
	if (size - result <	subLen)
	{
		return -1;
	}
	if (strnicmp(buffer + result, subStr, subLen) == 0)
	{
		return result;
	}
	else
	{
		return -1;
	}
}
//quote will be removed, end is boundary
bool findFirstWordA(LPCSTR buffer, int size, int& start, int& end)
{
	start = end =0;
	bool isQuote = false;
	bool isBegin = false;
	bool isEnd   = false;
	while (start < size)
	{  	
		if (buffer[start]=='"'||buffer[start] == '\'')
		{			
			isQuote = true;		
		}

		if (buffer[start]!='"' && buffer[start]!=' ' && buffer[start]!='\'')
		{
			break;		 
		}  	
		start ++;
	}


	if (start>= size)
	{
		return false;
	}
	end = start;
	while (end < size)
	{
		if (isQuote)
		{
			if (buffer[end] == '"'||buffer[end]=='\'')
			{
				break;
			}
		}
		else
		{
			if (buffer[end]==' '||buffer[end]=='>')
			{
				break;
			}
		}
		end++;
	}  
	if (end>= size)
	{
		return false;
	}
	return true;
}



int skipScriptA(LPCSTR buffer, int size)
{
	int offset = 0;
	int start = 0, end = 0;
	int result = 0;
	offset = findNextStringA(buffer, size, "script");
	if (offset < 0)
	{
		return -1;
	}
	offset += 6;
	if (buffer[offset] == ' ' || buffer[offset]== '>')
	{ 			
		result = offset;   
		offset = findFirstStringA(buffer + offset, size - offset, "/script");
		if (offset < 0)
		{
			return 	HTML_PARSE_ERROR;
		}
		result += offset + 7;
		return result;
	}
	return -1;
}

int findFirstBracketA(LPCSTR buffer, int size)
{
	int offset = 0, result = 0;
	
	while (result < size)
	{
		offset = findFirstSymbolA(buffer + result, size - result, '<');
		if (offset < 0)
		{
			return -1;
		}
		result += offset + 1;
		offset = skipScriptA(buffer + result, size - result);
		if (offset < 0)
		{
			return result;
		}
		result += offset;
	}
	return -1;
}

bool HtmlParser::init()
{
	startReadImage = true;
	//useDataBaseLink = true;	
	currentHostNameLength = 0;
	/*
	nameSetFile   = fopen("nameSet.data", "w+b");
	nameQueueFile = fopen("nameQueue.data", "w+b");
	linkSetFile   = fopen("linkSet.data", "w+b");
	linkQueueFile = fopen("linkQueue.data", "w+b");
	if (nameSetFile==NULL || nameQueueFile==NULL || linkSetFile==NULL||nameQueueFile==NULL)
	{
		return false;
	}
	*/
	if (!sqlHelper.init())
	{
		return false;
	}
}

int HtmlParser::findFirstImageW(LPCTSTR buffer, int size, DomainNameType& nameBuffer)
{
	int result = 0;
	int offset = 0;
	int start, end;
	while (result < size)
	{
		offset = findFirstCharW(buffer + result, size - result, _T('<'));
		if (offset < 0)
		{
			return -1;
		}
		result += offset + 1;
		
		offset = findNextStringW(buffer + result, size - result, _T("img "));
		if (offset < 0)
		{
			continue;
		}
		result += offset + 4;
		offset = findFirstStringW(buffer + result, size - result, _T("src"));
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 3;
		offset = findNextCharW(buffer + result, size - result, _T('='));
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 1;
		if (!findFirstWordW(buffer+result, size - result, start, end))
		{
			return HTML_PARSE_ERROR;
		}

		result += start;
		offset = end - start;
	
		if (offset > MaxDomainNameLength)
		{
			return HTML_PATH_MAX_ERROR;
		}  	

		_tcsncpy(nameBuffer.nameBuffer, buffer + result, offset);
		nameBuffer.nameBuffer[offset]= _T('\0');
		//_tprintf(_T("\n*********[%s]*********\n"), nameBuffer.nameBuffer);

		result += offset + 1;
		return result;
	}
	return -1;
}

int HtmlParser::findFirstLinkW(LPCTSTR buffer, int size, DomainNameType& nameBuffer)
{
	int result = 0;
	int offset = 0;
	int start, end;
	while (result < size)
	{
		offset = findFirstCharW(buffer + result, size - result, _T('<'));
		if (offset < 0)
		{
			return -1;
		}
		result += offset + 1;
		
		offset = findNextStringW(buffer + result, size - result, _T("a "));
		if (offset < 0)
		{
			continue;
		}
		result += offset + 2;
		offset = findFirstStringW(buffer + result, size - result, _T("href"));
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 4;
		offset = findNextCharW(buffer + result, size - result, _T('='));
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 1;
		if (!findFirstWordW(buffer+result, size - result, start, end))
		{
			return HTML_PARSE_ERROR;
		}

		result += start;
		offset = end - start;
	
		if (offset > MaxDomainNameLength)
		{
			return HTML_PATH_MAX_ERROR;
		}  	

		_tcsncpy(nameBuffer.nameBuffer, buffer + result, offset);
		nameBuffer.nameBuffer[offset]= _T('\0');
		//_tprintf(_T("\n*********[%s]*********\n"), nameBuffer.nameBuffer);

		result += offset + 1;
		return result;
	}
	return -1;
}

int HtmlParser::doParseBufferImageW(LPCTSTR buffer, int size)
{
	int offset = 0;
	int result = 0;
	int imageCounter = 0;
	DomainNameType domainName;
	NameResultPair resultPair;

	while (result < size)
	{
		offset = findFirstImageW(buffer + result, size - result, domainName);
		if (offset < 0)
		{
			break;
		}  		
		resultPair = nameSet.insert(domainName);
		if (resultPair.second)
		{
			nameQueue.push_back(domainName);
			imageCounter ++;  
		}
		//printf("set size[%d]\n", nameSet.size());

		result += offset;
		
	}
	return imageCounter;
}

int HtmlParser::doParseBufferLinkW(LPCTSTR buffer, int size)
{
	int offset = 0;
	int result = 0;
	int linkCounter = 0;
	DomainNameType domainName;
	NameResultPair resultPair;

	while (result < size)
	{
		offset = findFirstLinkW(buffer + result, size - result, domainName);
		if (offset < 0)
		{
			break;
		}
		resultPair = linkSet.insert(domainName);
		
		if (resultPair.second)
		{
			linkQueue.push_back(domainName);
			linkCounter ++;
			//_tprintf(_T("new link[%s]\n"), domainName.nameBuffer);

		}
		result += offset;
	}
	return linkCounter;
}

bool HtmlParser::isGB2312(LPCTSTR buffer)
{
	unsigned short sh = _T('<');
	//_tprintf(_T("[%u][%u]\n"), GB2312ConvertToUnicode(buffer[0]), sh);
	return (GB2312ConvertToUnicode(buffer[0]) == _T('<'));
}


void HtmlParser::convertGB2312Buffer(LPTSTR buffer, int size)
{
	for (int i= 0; i < size; i ++)
	{
		buffer[i] = GB2312ConvertToUnicode(buffer[i]);
	}
}

bool HtmlParser::isAnsi(LPCSTR buffer)
{
	int index =0;
	while (buffer[index] == ' ' || buffer[index]== 10 || buffer[index]==13)
	{
		index ++;
	}
	return buffer[index] == '<';
}



bool HtmlParser::parseBuffer(LPCTSTR www, LPTSTR buffer, int size, FILE* log, bool toDownload)
{		
	ImageFileFormat fileFormat;

	DomainNameType tempName;
	fileFormat = imageFileFormat((LPBYTE)buffer);
	if (fileFormat != Image_File_Format_UNKNOWN)
	{	
		_tcscpy(tempName.nameBuffer, www);
		if (addNewUrl(tempName, true, toDownload))
		{
			savePictureFile((LPBYTE)buffer, size, log);	
		}

		return false;	
	}

	if (true)
	{
		doParseBufferLinkA(www, (LPSTR)buffer, size, log, toDownload);
	
		doParseBufferImageA(www, (LPSTR)buffer, size, log, toDownload);  		
		
	}
	else
	{
		 /*
		if (isGB2312(buffer))
		{
			convertGB2312Buffer(buffer, size);
		}
		*/
			
		doParseBufferLinkW(buffer, size/sizeof(TCHAR));
		doParseBufferImageW(buffer, size/sizeof(TCHAR));
	}
	return true;
}

 
int HtmlParser::findFirstImageA(LPCSTR buffer, int size, DomainNameType& nameBuffer)
{
	int result = 0;
	int offset = 0;
	int start, end;
	LPSTR ptr = NULL;
	while (result < size)
	{
		offset = findFirstBracketA(buffer + result, size - result);
		//offset = findFirstBracketA(buffer + result, size - result);
		if (offset < 0)
		{
			return -1;
		}
		//result += offset;
		result += offset ;
		
		offset = findNextStringA(buffer + result, size - result, "img ");
		if (offset < 0)
		{
			continue;
		}
		result += offset + 4;
		offset = findFirstStringA(buffer + result, size - result, "src");
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 3;
		offset = findNextCharA(buffer + result, size - result, '=');
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 1;
		if (!findFirstWordA(buffer+result, size - result, start, end))
		{
			return HTML_PARSE_ERROR;
		}

		result += start;
		offset = end - start;
	
		if (offset > MaxDomainNameLength)
		{
			return HTML_PATH_MAX_ERROR;
		}  	

		trimLink(buffer + result, offset, nameBuffer.nameBuffer, false);
		/*
		for (int i = 0; i < offset; i ++)
		{
			_stprintf(nameBuffer.nameBuffer + i, _T("%C"), buffer[result + i]);
		}
		//strncpy((LPSTR)nameBuffer.nameBuffer, buffer + result, offset);
		//ptr = (LPSTR)(nameBuffer.nameBuffer);
		//ptr[offset]= '\0';

		nameBuffer.nameBuffer[offset]= _T('\0');
		*/
		

		result += offset + 1;
		//printf("\n*********[%s]*********\n", nameBuffer.nameBuffer);

		return result;
	}
	return -1;
}

unsigned short findPattern(LPCSTR str, int length, int& jump)
{
	unsigned short uIndex =0;

	if (str[0] == '&')
	{		
		if (length >= 4)
		{
			if (_strnicmp(str, "&amp;", 5) == 0)
			{
				jump = 5;
				return str[0];
			}
		}
		if (length >= 8)
		{	
			if (sscanf(str, "&#%u;", &uIndex)==1)
			{
				jump = 8;
				return uIndex;
			}			
		}
	}
	jump = 1;
	return str[0];
}



void trimLink(LPCSTR str, int length, LPTSTR buf, bool convert)
{
	unsigned short uIndex = 0;
	int i= 0, index =0;
	int jump;
	while (i < length) 
	{
		if (convert)
		{
			uIndex = findPattern(str + i, length - i, jump);
		}
		else
		{
			uIndex = str[i];
			jump = 1;
		}


		buf[index] = uIndex;
		i+= jump;
		
		index ++;
	}
	buf[index] = _T('\0');
	_tprintf(_T("trimLink["));
	for (i =0; i<index ; i++)
	{
		_tprintf(_T("%c"), buf[i]);
	}
	_tprintf(_T("]\n"));
}


int HtmlParser::findFirstLinkA(LPCSTR buffer, int size, DomainNameType& nameBuffer)
{
	int result = 0;
	int offset = 0;
	int start, end;
	LPSTR ptr = NULL;
	LPWSTR wptr = NULL;
	int counter=0;;
	while (result < size)
	{
		offset = findFirstBracketA(buffer + result, size - result);
		if (offset < 0)
		{
			return -1;
		}
		result += offset;
		
		offset = findNextStringA(buffer + result, size - result, "a ");
		if (offset < 0)
		{
			continue;
		}
		result += offset + 2;
		offset = findFirstStringA(buffer + result, size - result, "href");
		if (offset < 0)
		{
			continue;
			//return HTML_PARSE_ERROR;
		}
		result += offset + 4;
		offset = findNextCharA(buffer + result, size - result, '=');
		if (offset < 0)
		{
			return HTML_PARSE_ERROR;
		}
		result += offset + 1;
		if (!findFirstWordA(buffer+result, size - result, start, end))
		{
			return HTML_PARSE_ERROR;
		}

		result += start;
		offset = end - start;
	
		if (offset > MaxDomainNameLength)
		{
			return HTML_PATH_MAX_ERROR;
		}  	


		trimLink(buffer + result, offset, nameBuffer.nameBuffer, false);
		
		/*
		if ((len=MultiByteToWideChar(CP_OEMCP, MB_ERR_INVALID_CHARS, buffer+result, 
			offset, nameBuffer.nameBuffer, MaxDomainNameLength))==0)
		{
			printf("error [%u]\n", GetLastError());
		}
		else
		{
			nameBuffer.nameBuffer[len]=_T('\0');
		}
		*/
		
		//printf("\n*********[%s]*********\n", buffer + result);
		/*
		ptr = (LPSTR)(buffer + result);
		i = 0; 
		do 
		{
			if (buffer[result+i]>160 && buffer[result+i]<255)
			{
				wptr = (LPWSTR)(buffer+ result+i);
				nameBuffer.nameBuffer[counter] = *wptr;
				i++;
			}
			else
			{
				ptr = (LPSTR)(buffer + result + i);
				nameBuffer.nameBuffer[counter]= *ptr;
			}
			i++;
			counter++;
		}
		while (i<offset);
		nameBuffer.nameBuffer[counter] = _T('\0');
		*/
		//nameBuffer.nameBuffer[offset] = _T('\0');
		//strncpy((LPSTR)nameBuffer.nameBuffer, buffer + result, offset);
		//ptr =  (LPSTR)(nameBuffer.nameBuffer);
		//ptr[offset]= '\0';	
		
	
		

		result += offset + 1;
		
		return result;
	}
	return -1;
}

int HtmlParser::doParseBufferImageA(LPCTSTR www, LPCSTR buffer, int size, FILE* log, bool toDownload)
{
	int offset = 0;
	int result = 0;
	int imageCounter = 0;
	DomainNameType domainName, temp;
	NameResultPair resultPair;
	bool result1 = true, result2 = true;

	while (result < size)
	{
		offset = findFirstImageA(buffer + result, size - result, temp);
		if (offset < 0)
		{
			break;
		}  	
		combineUrl(www, temp.nameBuffer, domainName.nameBuffer, true);
		result1 =addNewUrl(domainName, true, toDownload);
		//result2 = addNewUrl(domainName, false, toDownload);
		if ( result1 && result2 )
		{		
			imageCounter ++;  
			
			_tprintf(_T("new image link[%s]\n"), domainName.nameBuffer);
			if (log != NULL)
			{
				_ftprintf(log, _T("new image link[%s]\n"), domainName.nameBuffer);
			}
		} 
		else
		{
			_tprintf(_T("repeated image link[%s]\n"), domainName.nameBuffer);
			if (log != NULL)
			{
				_ftprintf(log, _T("repeated image link[%s]\n"), domainName.nameBuffer);
			}
		}	

		result += offset;		
	}
	return imageCounter;
}

bool HtmlParser::n63specialize(LPCTSTR www, LPCTSTR link, LPTSTR buf, bool isImage)
{
	DWORD bufLength = MaxDomainNameLength;
	DomainNameType theHost;
	int hostLength;
	LPTSTR ptr;

	retrieveCurrentHost(www, theHost, hostLength); 
	if (_tcsicmp(theHost.nameBuffer, _T("http://www.n63.com/"))!=0)
	{
		return false;
	}
	_tprintf(_T("the link [%s]\n"), link);

	if (isImage)
	{
		if (_tcsnicmp(link, _T("http://"), 7)!=0)
		{  
			_stprintf(buf, _T("http://www.n63.com/photodir/%s"), link);
			_tprintf(_T("the new image [%s]\n"), buf); 
			return true;
		}
	}

	if (_tcsnicmp(link, _T("javascript:"), 11)==0)
	{
		if ((ptr = (LPTSTR)_tcschr(link+11, _T('\'')))!= NULL)
		{
			_stprintf(buf, _T("http://www.n63.com/photodir/%s"), ptr+1);
			if ((ptr = _tcschr(buf, _T('\'')))!= NULL)
			{
				*ptr = _T('\0');
				_tprintf(_T("the new link [%s]\n"), buf);
				return true;
			}
		}
	} 	

	return false;
}



TCHAR buffer[2048];
bool HtmlParser::combineUrl(LPCTSTR www, LPTSTR link, LPTSTR buf, bool isImage)
{
	DWORD bufLength = MaxDomainNameLength;
	
	DWORD len =0;

	//wchar_t* ptr = NULL;

	//retrieveCurrentHost(www, theHost, hostLength); 
	/*
	if (n63specialize(www, link, buf, isImage))
	{
		return true;
	}
	*/

	_tprintf(_T("host[%s] and the link[%s] is going to be combined\n"), www, link);
	if (InternetCombineUrl(www, link, buf, &bufLength, ICU_NO_ENCODE))
	{
		//only for japanese thud:
		/*
		ptr = wcsstr(buf, _T("amp;"));
		if (ptr != NULL)
		{
			len = (bufLength - (ptr - buf) - 4)*sizeof(wchar_t);
			memmove(ptr, ptr+4, len);
			bufLength -= 4;
		}
		*/
		buf[bufLength] = _T('\0'); 		
		_tprintf(_T("combined link[%s]\n"), buf);

		return true;
	}
	return false;
}



bool HtmlParser::addNewUrl(DomainNameType& domainName, bool isImageLink, bool toDownload)
{
	NameResultPair resultPair;
	bool result = false;

	if (!useDataBaseLink)
	{
		if (!isImageLink)
		{
			resultPair = linkSet.insert(domainName);
		}
		else
		{
			resultPair = nameSet.insert(domainName);
		}
	
		result = resultPair.second;
	}
	else
	{
		if (!isImageLink)
		{
			result = sqlHelper.insertNewLink(domainName, "myLink", "myLink", false);
		}
		else
		{
			result = sqlHelper.insertNewLink(domainName, "myName", "myName", true);
		}
	}

	if (result)
	{

		if (!isImageLink)
		{
			if (toDownload)
			{
				linkQueue.push_back(domainName);
			}
		
			_tprintf(_T("new link[%s]\n"), domainName.nameBuffer);
			result = true;
		}
		else
		{
			if (startReadImage)
			{			
				if (toDownload)
				{
					nameQueue.push_back(domainName);
				}
				_tprintf(_T("new image[%s]\n"), domainName.nameBuffer);
				result = true;
			}			
		}
		//printf("new link[%s]\n", domainName.nameBuffer);	
	}
	
	return result;
}

int HtmlParser::doParseBufferLinkA(LPCTSTR www, LPCSTR buffer, int size, FILE* log, bool toDownload)
{
	int offset = 0;
	int result = 0;
	int linkCounter = 0;
	DomainNameType domainName, temp;
	
	DWORD bufLength =  MaxDomainNameLength;  

	while (result < size)
	{
		offset = findFirstLinkA(buffer + result, size - result, temp);
		if (offset < 0)
		{
			break;
		}
		combineUrl(www, temp.nameBuffer, domainName.nameBuffer);

		if (addNewUrl(domainName, false, toDownload))
		{
			
			linkCounter ++;
			if (log != NULL)
			{
				_ftprintf(log, _T("new link[%s]\n"), domainName.nameBuffer);
			}
		}
		else
		{
			if (log != NULL)
			{
				_ftprintf(log, _T("repeat link[%s]\n"), domainName.nameBuffer);
			}	 
			_tprintf(_T("repeat link[%s]\n"), domainName.nameBuffer);
		}
		result += offset;
	}
	return linkCounter;
}


bool HtmlParser::retrieveCurrentHost(LPCTSTR www, DomainNameType& result, int& length)
{
	URL_COMPONENTS url_component;
	memset(&url_component, 0, sizeof(URL_COMPONENTS));
	url_component.dwHostNameLength = MaxDomainNameLength - 7;
	_stprintf(result.nameBuffer, _T("http://"));
	
	url_component.lpszHostName = result.nameBuffer + 7;
	if (InternetCrackUrl(www, _tcslen(www), ICU_DECODE, &url_component))
	{	 		
		length = url_component.dwHostNameLength + 7;
		/*
		if (result.nameBuffer[length] == _T('\\') 
			|| result.nameBuffer[length] == _T('/'))
		{
			length -- ;
		}
		*/
		if (result.nameBuffer[length-1] != _T('/'))
		{
			result.nameBuffer[length] = _T('/');
			length ++;
			result.nameBuffer[length] = _T('\0');
		}
		else
		{
			result.nameBuffer[length] = _T('\0');

		}  		
		//_tprintf(_T("the host name of url [%s] is [%s]\n"), www, result.nameBuffer);  
		return true;
	}
	else
	{
		_tprintf(_T("crack url[%s] error of %d\n"), www, GetLastError());
	}
	return false;
}

bool HtmlParser::outputFile()
{
	if (!outputQueue(nameQueueFile, nameQueue))
	{
		return false;
	}
	if (!outputQueue(linkQueueFile, linkQueue))
	{
		return false;
	}
	
	if (!outputSet(nameSetFile, nameSet))
	{
		return false;
	}
	if (!outputSet(linkSetFile, linkSet))
	{
		return false;
	}
	return true;
}

bool HtmlParser::outputQueue(FILE* stream, DomainNameQueue& theQue)
{
	DomainNameType* ptr=NULL;
	int count = 0;
	if (theQue.size() > 0)
	{
		ptr = (DomainNameType*)(&(*theQue.begin()));
		count = fwrite(ptr, sizeof(DomainNameType), theQue.size(), stream);
	}
	fclose(stream);
	return count == theQue.size();
}

bool HtmlParser::outputSet(FILE* stream, DomainNameSet& theSet)
{
	int count =0;
	DomainNameType* ptr=NULL;
	for (DomainNameSet::const_iterator it=theSet.begin(); it != theSet.end(); it++)
	{
		ptr = (DomainNameType*)(&(*it));
		count = fwrite(ptr, sizeof(DomainNameType), 1, stream);
		if (count != 1)
		{
			fclose(stream);
			return false;
		}
	}
	fclose(stream);
	return true;
}


bool HtmlParser::isOutsideHostName(LPCTSTR www)
{
	URL_COMPONENTS url_component;
	DomainNameType  theHost;
	int counter = 0;
	int i, j;
	memset(&url_component, 0, sizeof(URL_COMPONENTS));
	url_component.dwHostNameLength = MaxDomainNameLength;
	url_component.lpszHostName = theHost.nameBuffer;
	if (InternetCrackUrl(www, _tcslen(www), ICU_DECODE, &url_component))
	{
		if (url_component.lpszHostName[url_component.dwHostNameLength-1] != _T('/'))
		{
			url_component.lpszHostName[url_component.dwHostNameLength] = _T('/');
			url_component.dwHostNameLength ++;
			url_component.lpszHostName[url_component.dwHostNameLength] = _T('\0');
		}
		else
		{
			url_component.lpszHostName[url_component.dwHostNameLength] = _T('\0');
		}
		_tprintf(_T("www url[%s]hostname[%s],link[%s]\n"), www, currentHost.nameBuffer, 
			url_component.lpszHostName);

		if (useStrictLink)
		{
			return _tcsnicmp(currentHost.nameBuffer, theHost.nameBuffer, currentHostNameLength)==0;
		}
		for (i = currentHostNameLength - 1, j = _tcslen(theHost.nameBuffer) - 1;  
			i >= 0, j >= 0; i --, j--)
		{
			if (currentHost.nameBuffer[i] != theHost.nameBuffer[j])
			{
				return true;
			}
			if (currentHost.nameBuffer[i] == _T('.'))
			{
				counter ++ ;
			}
			if (counter == 2)
			{
				return false;  				
			}
		}		
		//_tcsicmp(theHost.nameBuffer, currentHost.nameBuffer)!=0;
	}
	return false;
}








