#include "stdafx.h"


extern FILE* log;

int HttpClient::searchLevel = 5;
int HttpClient::searchLimit = 1000000;

HttpClient::HttpClient()
{
	log = NULL;
	hSession = hFile = NULL;
	bufferSize = 0;
	htmlParser.useDataBaseLink = true;	
}

bool HttpClient::init()
{
	if (!htmlParser.init())
	{
		return false;
	}
	if (!mySqlHelper.init())
	{
		return false;
	}
	if ((log = fopen("httpclient.log", "a"))== NULL)
	{
		_tprintf(_T("cannot open log\n"));
		return false;
	}	
	return true;
}

HttpClient::~HttpClient()
{	
	if (hSession != NULL)
	{
		InternetCloseHandle(hSession);
	}
	if (log != NULL)
	{
		fclose(log);
	}
}

bool HttpClient::combineUrl(URL_COMPONENTS& url, LPCTSTR link, LPTSTR buffer, int bufSize)
{
	int offset =0;
	int bufOffset = 0;
	int i, j;
	TCHAR temp[64];

	//_tprintf(_T("link=[%s]\n"), link);
	offset = findFirstStringW(link, _tcslen(link), _T("://"));
	if (offset < 0)
	{
		_sntprintf(buffer+bufOffset, url.dwSchemeLength, _T("%s"), url.lpszScheme);
		bufOffset += url.dwSchemeLength;
		_sntprintf(buffer+bufOffset, 3, _T("://"));
		bufOffset += 3;
		for (i = url.dwHostNameLength; i>= 0; i--)
		{
			if (url.lpszHostName[i] !=_T(' '))
			{
				break;
			}
		}
		_tcsncpy(buffer + bufOffset, url.lpszHostName, i);
		bufOffset += url.dwHostNameLength;
		buffer[bufOffset]= '\0';
		//_tprintf(_T("[%s]\n"), buffer);
		j = skipSpaceW(link, _tcslen(link));

		strncpy((char*)temp, (char*)url.lpszHostName, url.dwHostNameLength);
		temp[url.dwHostNameLength]='\0';
		//printf("[%s]\n", (char*)temp);

		bufOffset += i + 1;
		if (url.lpszHostName[i] != _T('/'))
		{				
			if (link[j] != _T('/'))
			{
				buffer[bufOffset] = _T('/');
				bufOffset++;
				_tcscpy(buffer+ bufOffset, link + j);
			}
			else
			{
				_tcscpy(buffer+ bufOffset, link + j);
			}
			bufOffset += _tcslen(link) - j;
			//_tprintf(_T("[%s]\n"), buffer);
		}
		else
		{

			if (link[j] == _T('/'))
			{
				_tcscpy(buffer+bufOffset , link+j+1);
				bufOffset += _tcslen(link) - j -1;

			}
			else
			{
				_tcscpy(buffer+bufOffset , link+j);
				bufOffset += _tcslen(link) - j;	 
			}
			//_tprintf(_T("[%s]\n"), buffer);
		}
		buffer[bufOffset] = _T('\0');
		//_tprintf(_T("[%s]\n"), buffer);
	}
	else
	{
		_tcscpy(buffer, link);
	}
	return true;
}

bool HttpClient::doDownloadImage()
{
	DomainNameType theName;

	while (!htmlParser.nameQueue.empty())
	{
		theName = htmlParser.nameQueue.front();
		_tprintf(_T("picture link[%s] is about to be read\n"), theName.nameBuffer);
		_ftprintf(log, _T("picture link[%s] is about to be read\n"), theName.nameBuffer);

	
		if (readWebSite(theName.nameBuffer, 1))
		{
			savePictureFile((LPBYTE)buffer, bufferSize, log); 			
		}  	
		htmlParser.nameQueue.pop_front();
	}
	return true;
}

bool HttpClient::outputFile()
{
	return htmlParser.outputFile();
}

int HttpClient::downloader()
{
	int trialNumber =0;
	DomainNameType linkName;
	int result = 0;
	int newStatus = LinkStatusDead;
	int number;
	while (true)
	{
		if (mySqlHelper.retrieveAvailableLink(linkName, "myName"))
		{	
			if (mySqlHelper.setLinkToReading(linkName, "myName"))
			{			
				if ( evaluateLink(linkName.nameBuffer))
				{	
					if (readWebSite(linkName.nameBuffer, 1))
					{
						if (savePictureFile((LPBYTE)buffer, bufferSize, log))
						{
							result ++;							
						}						
						newStatus = LinkStatusImage;						
					}
				}

				if (!mySqlHelper.setLinkToFinished(linkName, "myName", newStatus))
				{
					_stprintf(msgBuffer, _T("unexpected error of set link [%s] finished\n"),
						linkName.nameBuffer);
					debugPrintout();
				}		
			}
		}	
		else
		{
			if (mySqlHelper.retrieveAvailableLinkNumber(number, "myname"))
			{
 				if (number ==0)
				{
					break;
				}
			}			
		}
	}
	return result;
/*
	while (true)
	{
		if (mySqlHelper.retrieveAvailableLink(linkName, "myName"))
		{				
			status = -1;
			if (mySqlHelper.fetchStatus(linkName, "myName", status))
			{
				_tprintf(_T("link[%s] status[%d] before set to reading\n"), linkName.nameBuffer, status);
			}

			if (mySqlHelper.setLinkToReading(linkName, "myName"))
			{
				status = -1;
				if (mySqlHelper.fetchStatus(linkName, "myName", status))
				{
					_tprintf(_T("link[%s] status[%d] after set to reading\n"), linkName.nameBuffer, status);
				}
				if ( evaluateLink(linkName.nameBuffer))
				{	
					if (readWebSite(linkName.nameBuffer, 1))
					{
						if (savePictureFile((LPBYTE)buffer, bufferSize, log))
						{
							result ++;
						}
					}
				}
				if (!mySqlHelper.setLinkToFinished(linkName, "myName"))
				{
					_stprintf(msgBuffer, _T("unexpected error of set link [%s] finished\n"),
						linkName.nameBuffer);
					debugPrintout();
				}
				status = -1;
				if (mySqlHelper.fetchStatus(linkName, "myName", status))
				{
					_tprintf(_T("link[%s] status[%d] after set to finished\n"), linkName.nameBuffer, status);
				}
			}
		}	
		else
		{
			break;
		}
	}
	return result;
	*/
}




int HttpClient::uploader()
{
	//int trialNumber =0;
	DomainNameType linkName;
	int result = 0;
	int newStatus =0;
	int number = 0;

	while (true)
	{	
		try
		{
			if (mySqlHelper.retrieveAvailableLink(linkName, "mylink"))
			{	
				try
				{
					if (mySqlHelper.setLinkToReading(linkName, "mylink"))
					{
						try
						{
							newStatus = uploadWebSite(linkName.nameBuffer);
							if (newStatus == LinkStatusImage)
							{
								result ++;
							}
							if (!mySqlHelper.setLinkToFinished(linkName, "mylink", newStatus))
							{
								_stprintf(msgBuffer, _T("unexpected error of set link [%s] finished\n"),
									linkName.nameBuffer);
								debugPrintout();
							}
						}
						catch(...)
						{
							printf("3\n");
						}
					}
				}
				catch (...)
				{
					printf("2\n");
				}
			}
			else	
			{
		
				if (mySqlHelper.retrieveAvailableLinkNumber(number, "mylink"))
				{
 					if (number ==0)
					{
						break;
					}
				}
			}
		}
		catch (...)
		{
			printf("1\n");
		}
	}
	//fclose(log);
	return result;
}

void HttpClient::debugPrintout()
{
#ifdef _DEBUG
	_ftprintf(log, _T("%s\n"), msgBuffer);
	_tprintf(_T("%s\n"), msgBuffer);
#endif
}

bool HttpClient::evaluateLink(LPCTSTR www)
{
	//will go to detail later
	bool result  = false;
	int status = 0;
	LPCTSTR MyOwnWeb = _T("http://nickhuang99.dynalias.com");
	int len = _tcslen(MyOwnWeb);
	if (_tcsnicmp(MyOwnWeb, www, len) == 0)
	{
		return false;
	}
	if (mySqlHelper.fetchStatus(www, "myHost", status))
	{
		result =  status > -100;
	}
	else
	{
		result = true;
	}
	return result;
}

int HttpClient::uploadWebSite(LPCTSTR www)
{
	int result = LinkStatusFinished;

	_stprintf(msgBuffer, _T("begin upload website [%s]\n"), www);
	debugPrintout();

	if (! evaluateLink(www))
	{
		return LinkStatusDead;
	}

	if (readWebSite(www))
	{		
		//only when the link is an image, we need this positive return
		if (! htmlParser.parseBuffer(www, (LPTSTR)buffer, bufferSize, log, false))
		{
			result = LinkStatusImage;
		}
		else
		{
			result = LinkStatusFinished;
		}

		fflush(log);			
	}
	else
	{
		result = LinkStatusDead;
	}
	return result;
}




int HttpClient::searchWebSite(LPCTSTR www)
{
	extern int saveCounter;
	extern FILE* crashFile;
	int linkCounter  = 0;
	int searchCounter = 0;
	int imageCounter = 0;
	int i;
	//TCHAR hostName[MaxDomainNameLength];
	//TCHAR schemeBuf[MaxDomainNameLength];
	DomainNameType theLink, theName;

	if (! htmlParser.init())
	{
		return 0;
	}

	if ((log = fopen("httpclient.log", "a"))== NULL)
	{
		_tprintf(_T("cannot open log\n"));
		return -1;
	}
	_stprintf(theLink.nameBuffer, _T("%s"), www);
	if (!htmlParser.useDataBaseLink)
	{
		htmlParser.linkSet.clear();
		htmlParser.linkSet.insert(theLink);
	}
	else
	{
		if (! htmlParser.addNewUrl(theLink, false))
		{
			return 0;
		}
	}
		

	if (readWebSite(www))
	{
		htmlParser.retrieveCurrentHost(www, htmlParser.currentHost, 
			htmlParser.currentHostNameLength);
		_ftprintf(log, _T("the host name is [%s]\n"), htmlParser.currentHost.nameBuffer);
		htmlParser.parseBuffer(www, (LPTSTR)buffer, bufferSize, log);
	}
	searchLevel --;
	htmlParser.startReadImage = true;
	//htmlParser.startReadImage = searchLevel == 0;
	linkCounter = htmlParser.linkQueue.size();
	while (!htmlParser.linkQueue.empty() && htmlParser.linkQueue.size()<200000 
		&& htmlParser.nameQueue.size()<80000 && searchCounter < searchLimit
		&& searchLevel>= 0)
	{
		theLink = htmlParser.linkQueue.front();			
		
		_tprintf(_T("the link[%s] is going to be read\n"), theLink.nameBuffer);
		_ftprintf(log, _T("the link[%s] is going to be read\n"), theLink.nameBuffer);
		
		if (!htmlParser.isOutsideHostName(theLink.nameBuffer))
		{
			if (readWebSite(theLink.nameBuffer, 1))
			{
								
				_ftprintf(log, _T("************link[%s] will be parsed********\n"), theLink.nameBuffer);
				_tprintf(_T("*************link[%s] will be parsed*************\n"), theLink.nameBuffer);
				if (!htmlParser.parseBuffer(theLink.nameBuffer, (LPTSTR)buffer, bufferSize, log))
				{
					imageCounter++;
				}
				//doDownloadImage();
			}
		}
		else
		{
			_tprintf(_T("outside host [%s]\n"), theLink.nameBuffer);
			_ftprintf(log, _T("link[%s] is outside [%s]\n"), theLink.nameBuffer, www);
		} 
		htmlParser.linkQueue.pop_front();
		linkCounter --;
		if (linkCounter == 0)
		{
			searchLevel --;
			linkCounter = htmlParser.linkQueue.size();
			if (searchLevel ==0)
			{
				htmlParser.startReadImage = true;
			}
		}
		fflush(log);
		searchCounter ++; 
	}
	imageCounter = htmlParser.nameQueue.size();
	doDownloadImage();
	
	
	printf("total link count[%d], total image[%d] total save count [%d]\n", 
		searchCounter, imageCounter, saveCounter);
	fprintf(log, "total link count[%d], total image[%d] total save count [%d]\n", 
		searchCounter, imageCounter, saveCounter);
	fclose(log);
	return saveCounter;
}

bool HttpClient::readWebSite(LPCTSTR www, int trialNumber)
{
	int trial = 0;
	while (trial < trialNumber)
	{
		if (readWebSite(www))
		{
			return true;
		}
		trial ++;
	}
	return false;
}


/////////////////////////////////////////////////////////////////////////////////////////////
bool HttpClient::readWebSite(LPCTSTR www)
{   
	DWORD size = 0;
	int offset = 0;
	bool result = true;
  	_tprintf(_T("\nread website[www]=[%s]\n"), www);
	_ftprintf(log, _T("\nread website[www]=[%s]\n"), www);

	if ((hSession = InternetOpen(_T("Microsoft Internet Explorer"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, INTERNET_DEFAULT_HTTP_PORT)) 
			  == NULL)
	{
		return false;
	}  	

	if ((hFile = InternetOpenUrl(hSession, www, _T("Accept: */*") , 11, INTERNET_FLAG_RELOAD, NULL))!= NULL)
	{  			
		while (InternetReadFile(hFile, buffer + offset, BufferSize, &size))
		{
			if (size == 0)
			{
				bufferSize = offset;				
			    break;
			}
			offset += size;
			if (offset > BufferSize)
			{
				printf("************************buffer overflow!***************************\n");
				result = false;
				break;
			}
		}  
		if (size != 0)
		{
			_tprintf(_T("read web page [%s] error!!!!!!!!!!!!!\n"), www);
			_ftprintf(log, _T("read web page [%s] error!!!!!!!!!!!!!\n"), www);
			result= false;
		}
		else
		{
			bufferSize = offset;
		}


		if (InternetCloseHandle(hFile))
		{
			hFile = NULL;
		}
		else
		{
			printf("error of close handle\n");
			result = false;
		}
	}
	else
	{
		printf("\n\n%d\n\n", GetLastError());
	}
	if (InternetCloseHandle(hSession))
	{
		hFile = NULL;
	}

    return result;
}



